package mod.mcreator;

import net.minecraftforge.fml.relauncher.SideOnly;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.common.registry.GameRegistry;
import net.minecraftforge.fml.common.registry.EntityEntry;
import net.minecraftforge.fml.common.network.NetworkRegistry;
import net.minecraftforge.fml.common.network.IGuiHandler;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;
import net.minecraftforge.fml.common.event.FMLServerStartingEvent;
import net.minecraftforge.fml.common.event.FMLPreInitializationEvent;
import net.minecraftforge.fml.common.event.FMLInitializationEvent;
import net.minecraftforge.fml.common.SidedProxy;
import net.minecraftforge.fml.common.Mod.Instance;
import net.minecraftforge.fml.common.Mod.EventHandler;
import net.minecraftforge.fml.common.Mod;
import net.minecraftforge.fml.common.IWorldGenerator;
import net.minecraftforge.fml.common.IFuelHandler;
import net.minecraftforge.fluids.FluidRegistry;
import net.minecraftforge.event.RegistryEvent;
import net.minecraftforge.common.MinecraftForge;
import net.minecraftforge.client.event.ModelRegistryEvent;

import net.minecraft.world.gen.IChunkGenerator;
import net.minecraft.world.chunk.IChunkProvider;
import net.minecraft.world.biome.Biome;
import net.minecraft.world.World;
import net.minecraft.item.ItemStack;
import net.minecraft.item.Item;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.block.Block;

import java.util.function.Supplier;
import java.util.Random;
import java.util.List;
import java.util.ArrayList;

@Mod(modid = survival_overhaul.MODID, version = survival_overhaul.VERSION, dependencies = "required-after:forge@[14.23.5.2768]")
public class survival_overhaul implements IFuelHandler, IWorldGenerator {

	public static final String MODID = "survival_overhaul";
	public static final String VERSION = "1.0.0";
	@SidedProxy(clientSide = "mod.mcreator.ClientProxysurvival_overhaul", serverSide = "mod.mcreator.CommonProxysurvival_overhaul")
	public static CommonProxysurvival_overhaul proxy;
	@Instance(MODID)
	public static survival_overhaul instance;
	public final List<ModElement> elements = new ArrayList<>();
	public final List<Supplier<Block>> blocks = new ArrayList<>();
	public final List<Supplier<Item>> items = new ArrayList<>();
	public final List<Supplier<Biome>> biomes = new ArrayList<>();
	public final List<Supplier<EntityEntry>> entities = new ArrayList<>();

	public survival_overhaul() {
		FluidRegistry.enableUniversalBucket();
		elements.add(new mcreator_sandstonePickaxe(this));
		elements.add(new mcreator_sandstoneShovel(this));
		elements.add(new mcreator_sandstoneAxe(this));
		elements.add(new mcreator_sandstoneHoe(this));
		elements.add(new mcreator_sandstoneSword(this));
		elements.add(new mcreator_sandstoneIngot(this));
		elements.add(new mcreator_sIngot(this));
		elements.add(new mcreator_sPick(this));
		elements.add(new mcreator_sSpade(this));
		elements.add(new mcreator_sHoe(this));
		elements.add(new mcreator_sAxe(this));
		elements.add(new mcreator_sSword(this));
		elements.add(new mcreator_oIngot(this));
		elements.add(new mcreator_oArmor(this));
		elements.add(new mcreator_obsidiantIngot(this));
		elements.add(new mcreator_oHelmet(this));
		elements.add(new mcreator_oChest(this));
		elements.add(new mcreator_oLeggings(this));
		elements.add(new mcreator_oBoots(this));
		elements.add(new mcreator_bauxite(this));
		elements.add(new mcreator_aluminumIngot(this));
		elements.add(new mcreator_aIngot(this));
		elements.add(new mcreator_steelIngot(this));
		elements.add(new mcreator_stIngot(this));
		elements.add(new mcreator_steelBlock(this));
		elements.add(new mcreator_sBlock(this));
		elements.add(new mcreator_copperOre(this));
		elements.add(new mcreator_copperIngot(this));
		elements.add(new mcreator_cIngot(this));
		elements.add(new mcreator_cassiterite(this));
		elements.add(new mcreator_tinIngot(this));
		elements.add(new mcreator_tIngot(this));
		elements.add(new mcreator_tinCopperComp(this));
		elements.add(new mcreator_bronze(this));
		elements.add(new mcreator_tinCopperCompo(this));
		elements.add(new mcreator_bronzeIngot(this));
		elements.add(new mcreator_bronzeAxe(this));
		elements.add(new mcreator_bronzeShovel(this));
		elements.add(new mcreator_bHoe(this));
		elements.add(new mcreator_bSword(this));
		elements.add(new mcreator_bronzePickaxe(this));
		elements.add(new mcreator_bAxe(this));
		elements.add(new mcreator_bShovel(this));
		elements.add(new mcreator_brHoe(this));
		elements.add(new mcreator_brSword(this));
		elements.add(new mcreator_bPickaxe(this));
		elements.add(new mcreator_anomolyOnBlockRightClicked(this));
		elements.add(new mcreator_anomoly(this));
		elements.add(new mcreator_anomolys(this));
		elements.add(new mcreator_heavyBlastFurnace(this));
		elements.add(new mcreator_heavyBlastFurnaceUI(this));
		elements.add(new mcreator_proHBlastFurnaceOpen(this));
		elements.add(new mcreator_proHBlastFurnaceCrafting1(this));
		elements.add(new mcreator_heavyBlastFurnaceRecipe(this));
		elements.add(new mcreator_alphaDimGrassBlock(this));
		elements.add(new mcreator_alphaDimDirtBlock(this));
		elements.add(new mcreator_alphaDimStoneBlock(this));
		elements.add(new mcreator_alphaWater(this));
		elements.add(new mcreator_alpha(this));
		elements.add(new mcreator_alphaDim(this));
		elements.add(new mcreator_alphaPlayerEntersDimension(this));
		elements.add(new mcreator_alphaPlains(this));
		elements.add(new mcreator_alphaOcean(this));
		elements.add(new mcreator_alphaWood(this));
		elements.add(new mcreator_alphaLeaves(this));
		elements.add(new mcreator_alphaRampentGuard(this));
	}

	@Override
	public int getBurnTime(ItemStack fuel) {
		for (ModElement element : elements) {
			int ret = element.addFuel(fuel);
			if (ret != 0)
				return ret;
		}
		return 0;
	}

	@Override
	public void generate(Random random, int chunkX, int chunkZ, World world, IChunkGenerator cg, IChunkProvider cp) {
		elements.forEach(element -> element.generateWorld(random, chunkX * 16, chunkZ * 16, world, world.provider.getDimension(), cg, cp));
	}

	@SubscribeEvent
	public void registerBlocks(RegistryEvent.Register<Block> event) {
		event.getRegistry().registerAll(blocks.stream().map(Supplier::get).toArray(Block[]::new));
	}

	@SubscribeEvent
	public void registerItems(RegistryEvent.Register<Item> event) {
		event.getRegistry().registerAll(items.stream().map(Supplier::get).toArray(Item[]::new));
	}

	@SubscribeEvent
	public void registerBiomes(RegistryEvent.Register<Biome> event) {
		event.getRegistry().registerAll(biomes.stream().map(Supplier::get).toArray(Biome[]::new));
	}

	@SubscribeEvent
	public void registerEntities(RegistryEvent.Register<EntityEntry> event) {
		event.getRegistry().registerAll(entities.stream().map(Supplier::get).toArray(EntityEntry[]::new));
	}

	@SubscribeEvent
	public void registerSounds(RegistryEvent.Register<net.minecraft.util.SoundEvent> event) {
	}

	@SubscribeEvent
	@SideOnly(Side.CLIENT)
	public void registerModels(ModelRegistryEvent event) {
		elements.forEach(element -> element.registerModels(event));
	}

	@EventHandler
	public void preInit(FMLPreInitializationEvent event) {
		MinecraftForge.EVENT_BUS.register(this);
		GameRegistry.registerFuelHandler(this);
		GameRegistry.registerWorldGenerator(this, 5);
		NetworkRegistry.INSTANCE.registerGuiHandler(this, new GuiHandler());
		elements.forEach(element -> element.preInit(event));
		proxy.preInit(event);
	}

	@EventHandler
	public void init(FMLInitializationEvent event) {
		elements.forEach(element -> element.init(event));
		proxy.init(event);
	}

	@EventHandler
	public void serverLoad(FMLServerStartingEvent event) {
		elements.forEach(element -> element.serverLoad(event));
	}

	public static class GuiHandler implements IGuiHandler {

		@Override
		public Object getServerGuiElement(int id, EntityPlayer player, World world, int x, int y, int z) {
			if (id == mcreator_heavyBlastFurnaceUI.GUIID)
				return new mcreator_heavyBlastFurnaceUI.GuiContainerMod(world, x, y, z, player);
			return null;
		}

		@Override
		public Object getClientGuiElement(int id, EntityPlayer player, World world, int x, int y, int z) {
			if (id == mcreator_heavyBlastFurnaceUI.GUIID)
				return new mcreator_heavyBlastFurnaceUI.GuiWindow(world, x, y, z, player);
			return null;
		}
	}

	public static class ModElement {

		public static survival_overhaul instance;

		public ModElement(survival_overhaul instance) {
			this.instance = instance;
		}

		public void init(FMLInitializationEvent event) {
		}

		public void preInit(FMLPreInitializationEvent event) {
		}

		public void generateWorld(Random random, int posX, int posZ, World world, int dimID, IChunkGenerator cg, IChunkProvider cp) {
		}

		public void serverLoad(FMLServerStartingEvent event) {
		}

		public void registerModels(ModelRegistryEvent event) {
		}

		public int addFuel(ItemStack fuel) {
			return 0;
		}
	}
}
